#include "xyz.hh"
#include "mapdefs.hh"
#include "rgb.hh"

/* This is in memory. */
class MapWall
{
public:
    XYZ p1, p2;
    Pigment Pigm;
public:
    MapWall() { }
    MapWall(const wall &w, const v3 *verts);
    
    bool hits(const XYZ &a, const XYZ &b) const;
    bool IsObstacle(const XYZ &eye, const XYZ &dir) const;
    
    /* Returns the point of hitting (absolute) */
    const XYZ HitPoint(const XYZ &eye, const XYZ &dir) const;
    
    inline const FLOAT minx() const { return p1.x <? p2.x; }
    inline const FLOAT miny() const { return p1.y <? p2.y; }
    inline const FLOAT minz() const { return p1.z <? p2.z; }
    inline const FLOAT maxx() const { return p1.x >? p2.x; }
    inline const FLOAT maxy() const { return p1.y >? p2.y; }
    inline const FLOAT maxz() const { return p1.z >? p2.z; }
};

#include "autoptr"
class Map
{
    MapWall *Walls;
    unsigned WallCount;
    
    autoptr<class bsp> tree;
    
    MapWall *FindObstacleWith(const XYZ &eye, const XYZ &dir, const bsp *);

public:
    Map();
    ~Map();

    void Load(const v3 *verts, unsigned vcount,
              const wall *walls, unsigned wcount);
    
    MapWall *FindObstacle(const XYZ &eye, const XYZ &dir);
};
